com.tibbo.aggregate.common.expression

## Class DefaultReferenceResolver

- java.lang.Object
- - com.tibbo.aggregate.common.expression.AbstractReferenceResolver
  - - com.tibbo.aggregate.common.expression.DefaultReferenceResolver

- All Implemented Interfaces:
    ReferenceResolver

      public class DefaultReferenceResolver
      extends AbstractReferenceResolver

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DESCRIPTION`
    `static java.lang.String` | `FORMAT`
    `static java.lang.String` | `HELP`
    `static java.lang.String` | `ICON`
    `static java.lang.String` | `NAME`
    `static java.lang.String` | `OPTIONS`
    `static java.lang.String` | `QUALITY`
    `static java.lang.String` | `READABLE`
    `static java.lang.String` | `RECORDS`
    `static java.lang.String` | `ROW`
    `static java.lang.String` | `SELECTION_VALUE_DESCRIPTION`
    `static java.lang.String` | `TIMESTAMP`
    `static java.lang.String` | `TYPE`
    `static java.lang.String` | `WRITABLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DefaultReferenceResolver()`
    `DefaultReferenceResolver(DataTable defaultTable)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Context` | `getContext(Reference ref)`
    `java.util.List<Context>` | `getContexts(Reference ref)`
    `protected java.lang.Object` | `getDefaultTableAggregate(DataTable table)`
    `protected java.lang.Integer` | `getRow(Reference ref, EvaluationEnvironment environment)`
    `protected DataTable` | `resolveEntity(Reference ref, Context con, EvaluationEnvironment environment)`
    `java.lang.Object` | `resolveReference(Reference ref, EvaluationEnvironment environment)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class com.tibbo.aggregate.common.expression.AbstractReferenceResolver

      `addContextManager, getCallerController, getContextManager, getDefaultContext, getDefaultRow, getDefaultTable, getEvaluator, setCallerController, setContextManager, setDefaultContext, setDefaultRow, setDefaultTable, setEvaluator`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ROW

          public static final java.lang.String ROW

      See Also:
        Constant Field Values

    - #### DESCRIPTION

          public static final java.lang.String DESCRIPTION

      See Also:
        Constant Field Values

    - #### NAME

          public static final java.lang.String NAME

      See Also:
        Constant Field Values

    - #### ICON

          public static final java.lang.String ICON

      See Also:
        Constant Field Values

    - #### TYPE

          public static final java.lang.String TYPE

      See Also:
        Constant Field Values

    - #### READABLE

          public static final java.lang.String READABLE

      See Also:
        Constant Field Values

    - #### WRITABLE

          public static final java.lang.String WRITABLE

      See Also:
        Constant Field Values

    - #### RECORDS

          public static final java.lang.String RECORDS

      See Also:
        Constant Field Values

    - #### QUALITY

          public static final java.lang.String QUALITY

      See Also:
        Constant Field Values

    - #### TIMESTAMP

          public static final java.lang.String TIMESTAMP

      See Also:
        Constant Field Values

    - #### FORMAT

          public static final java.lang.String FORMAT

      See Also:
        Constant Field Values

    - #### HELP

          public static final java.lang.String HELP

      See Also:
        Constant Field Values

    - #### OPTIONS

          public static final java.lang.String OPTIONS

      See Also:
        Constant Field Values

    - #### SELECTION_VALUE_DESCRIPTION

          public static final java.lang.String SELECTION_VALUE_DESCRIPTION

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DefaultReferenceResolver

          public DefaultReferenceResolver()

    - #### DefaultReferenceResolver

          public DefaultReferenceResolver(DataTable defaultTable)

  - ### Method Detail

    - #### resolveReference

          public java.lang.Object resolveReference(Reference ref,
                                                   EvaluationEnvironment environment)
                                            throws SyntaxErrorException,
                                                   EvaluationException,
                                                   ContextException

      Throws:
        `SyntaxErrorException`
        `EvaluationException`
        `ContextException`

    - #### getDefaultTableAggregate

          protected java.lang.Object getDefaultTableAggregate(DataTable table)

    - #### getRow

          protected java.lang.Integer getRow(Reference ref,
                                             EvaluationEnvironment environment)

    - #### getContexts

          public java.util.List<Context> getContexts(Reference ref)
                                              throws ContextException

      Throws:
        `ContextException`

    - #### getContext

          public Context getContext(Reference ref)
                             throws ContextException

      Throws:
        `ContextException`

    - #### resolveEntity

          protected DataTable resolveEntity(Reference ref,
                                            Context con,
                                            EvaluationEnvironment environment)
                                     throws ContextException,
                                            SyntaxErrorException,
                                            EvaluationException

      Throws:
        `ContextException`
        `SyntaxErrorException`
        `EvaluationException`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`